POJ 2449 Remmarguts‘ Date---SPFA求评估函数 + A*最小堆BFS

POJ 2449 Remmarguts’ Date

Time Limit: 4000MS Memory Limit: 65536K

Description

“Good man never makes girls wait or breaks an appointment!” said the mandarin duck father. Softly touching his little ducks’ head, he told them a story.

“Prince Remmarguts lives in his kingdom UDF – United Delta of Freedom. One day their neighboring country sent them Princess Uyuw on a diplomatic mission.”

“Erenow, the princess sent Remmarguts a letter, informing him that she would come to the hall and hold commercial talks with UDF if and only if the prince go and meet her via the K-th shortest path. (in fact, Uyuw does not want to come at all)”

Being interested in the trade development and such a lovely girl, Prince Remmarguts really became enamored. He needs you - the prime minister’s help!

DETAILS: UDF’s capital consists of N stations. The hall is numbered S, while the station numbered T denotes prince’ current place. M muddy directed sideways connect some of the stations. Remmarguts’ path to welcome the princess might include the same station twice or more than twice, even it is the station with number S or T. Different paths with same length will be considered disparate.

Input

The first line contains two integer numbers N and M (1 <= N <= 1000, 0 <= M <= 100000). Stations are numbered from 1 to N. Each of the following M lines contains three integer numbers A, B and T (1 <= A, B <= N, 1 <= T <= 100). It shows that there is a directed sideway from A-th station to B-th station with time T.

The last line consists of three integer numbers S, T and K (1 <= S, T <= N, 1 <= K <= 1000).

Output

A single line consisting of a single integer number: the length (time required) to welcome Princess Uyuw using the K-th shortest path. If K-th shortest path does not exist, you should output “-1” (without quotes) instead.

Sample Input

2 2
1 2 5
2 1 4
1 2 2

Sample Output

14

思路

  1. 先用SPFA对终点求反向最短路(这里是有向图,要把边反向存储在另一空间内),得到了终点到各个点的最短路径
  2. 若不能到达源点说明无解返回-1,若终点和源点相同,那么要把k+ 1,因为这个路径为0,无效。
  3. 然后BFS中的优先队列重写比较函数,选取评估结果 + dist 最优的点进入下一步,实现A*的思路。

Code

#include<iostream>
#include<cstring>
#include<queue>
using namespace std;

const int maxn = 1e3 + 3;
const int maxm = 1e5 + 3;
const int inf = 0x3f3f3f3f;

int f[maxn], head[maxn], reverse_head[maxn];
bool inq[maxn];

struct way {
    int node, dist, f;
    way(int node = 0, int dist = 0, int f = 0) : node(node), dist(dist), f(f) {}

    bool operator < (const way& other) const{
        if (f == other.f) return dist > other.dist;
        return f > other.f;
    }   
};

struct edge {
    int to, val, next;
    edge(int to = 0, int val = 0, int next = 0) : to(to), val(val), next(next){}
}edges[maxm], reverse_edges[maxm];

inline int read() {
    int x = 0, f = 1; char ch = getchar();
    while (ch < '0' || ch > '9') { if (ch == '-') f = -1; ch = getchar(); }
    while (ch >= '0' && ch <= '9') x = x * 10 + ch - 48, ch = getchar();
    return x * f;
}

void spfa(int s) {
    memset(f, inf, sizeof(f));
    memset(inq, false, sizeof(inq));
    f[s] = 0; 
    queue<int> q;
    q.push(s);
    inq[s] = true;
    while (q.size()) {
        int now = q.front(); q.pop();
        inq[now] = false;
        for (int i = reverse_head[now]; i; i = reverse_edges[i].next) {
            int to = reverse_edges[i].to, val = reverse_edges[i].val;
            if (f[to] > f[now] + val) {
                f[to] = f[now] + val;
                if (!inq[to]) {
                    q.push(to);
                    inq[to] = true;
                }
            }
        }
    }
}

int bfs(int s, int e, int k) {
    // 找最终点到各个点的最短路径,确立评估函数f,依次使用A*算法来帮助小根堆BFS优化
    spfa(e);
    // 若是没有通路直接返回-1
    if (f[s] == inf) return -1;
    // 当前找到第cnt短路
    int now_k = 0;
    // 如果起点就是终点
    if (s == e) k++;

    priority_queue<way> pq;
    pq.push(way(s, 0, f[s]));
    
    while (pq.size()) {
        way top = pq.top(); pq.pop();
        int now = top.node, dist = top.dist;
        // 若找到第k短路返回
        if (now == e) {
            ++now_k;
            if (now_k == k) return dist;
        }

        for (int i = head[now]; i; i = edges[i].next) {
            int to = edges[i].to, new_dist = dist + edges[i].val;
            pq.push(way(to, new_dist, new_dist + f[to]));
        }
    }
    return -1;
}

int main() {
    int n, m, a, b, t, s, e, k;
    while (cin >> n >> m) {
        memset(edges, 0, sizeof(edges));
        memset(reverse_edges, 0, sizeof(reverse_edges));
        memset(head, 0, sizeof(head));
        memset(reverse_head, 0, sizeof(reverse_head));

        for (int i = 1; i <= m; i++) {
            a = read(); b = read(); t = read();
            edges[i] = edge(b, t, head[a]);
            head[a] = i;
            // 为了反向找终点的最短路的处理
            reverse_edges[i] = edge(a, t, reverse_head[b]);
            reverse_head[b] = i;
        }

        s = read(); e = read(); k = read();

        cout << bfs(s, e, k) << endl;
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论
这是一道比较经典的计数问题。题目描述如下: 给定一个 $n \times n$ 的网格图,其中一些格子被标记为障碍。一个连通块是指一些被标记为障碍的格子的集合,满足这些格子在网格图中连通。一个格子是连通的当且仅当它与另一个被标记为障碍的格子在网格图中有公共边。 现在,你需要计算在这个网格图中,有多少个不同的连通块,满足这个连通块的大小(即包含的格子数)恰好为 $k$。 这是一道比较经典的计数问题,一般可以通过计算生成函数的方法来解决。具体来说,我们可以定义一个生成函数 $F(x)$,其中 $[x^k]F(x)$ 表示大小为 $k$ 的连通块的个数。那么,我们可以考虑如何计算这个生成函数。 对于一个大小为 $k$ 的连通块,我们可以考虑它的形状。具体来说,我们可以考虑以该连通块的最左边、最上边的格子为起点,从上到下、从左到右遍历该连通块,把每个格子在该连通块中的相对位置记录下来。由于该连通块的大小为 $k$,因此这些相对位置一定是 $(x,y) \in [0,n-1]^2$ 中的 $k$ 个不同点。 现在,我们需要考虑如何计算这些点对应的连通块是否合法。具体来说,我们可以考虑从左到右、从上到下依次处理这些点,对于每个点 $(x,y)$,我们需要考虑它是否能够与左边的点和上边的点连通。具体来说,如果 $(x-1,y)$ 和 $(x,y)$ 都在该连通块中且它们在网格图中有公共边,那么它们就是连通的;同样,如果 $(x,y-1)$ 和 $(x,y)$ 都在该连通块中且它们在网格图中有公共边,那么它们也是连通的。如果 $(x,y)$ 与左边和上边的点都不连通,那么说明这个点不属于该连通块。 考虑到每个点最多只有两个方向需要检查,因此时间复杂度为 $O(n^2 k)$。不过,我们可以使用类似于矩阵乘法的思想,将这个过程优化到 $O(k^3)$ 的时间复杂度。 具体来说,我们可以设 $f_{i,j,k}$ 表示状态 $(i,j)$ 所代表的点在连通块中,且连通块的大小为 $k$ 的方案数。显然,对于一个合法的 $(i,j,k)$,我们可以考虑 $(i-1,j,k-1)$ 和 $(i,j-1,k-1)$ 这两个状态,然后把点 $(i,j)$ 加入到它们所代表的连通块中。因此,我们可以设计一个 $O(k^3)$ 的 DP 状态转移,计算 $f_{i,j,k}$。 具体来说,我们可以考虑枚举连通块所包含的最右边和最下边的格子的坐标 $(x,y)$,然后计算 $f_{x,y,k}$。对于一个合法的 $(x,y,k)$,我们可以考虑将 $(x,y)$ 所代表的点加入到 $(x-1,y,k-1)$ 和 $(x,y-1,k-1)$ 所代表的连通块中。不过,这里需要注意一个细节:如果 $(x-1,y)$ 和 $(x,y)$ 在网格图中没有相邻边,那么它们不能算作连通的。因此,我们需要特判这个情况。 最终,$f_{n,n,k}$ 就是大小为 $k$ 的连通块的个数,时间复杂度为 $O(n^2 k + k^3)$。 参考代码:

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值